//KULIC2

// GBackGround.cpp: implementation of the GBackGround class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GBackGround.h"
#include "GEngineKulic.h"
/*
// This will store the amount of vertices read in from the text file (.raw)
int g_NumberOfVerts = 0;

// The maximum amount of triangles per node.  If a node has equal or less 
// than this, stop subdividing and store the verts in that node
int g_MaxTriangles = 100;

// The maximum amount of subdivisions allowed (Levels of subdivision)
int g_MaxSubdivisions = 5;

// The current amount of end nodes in our tree (The nodes with vertices stored in them)
int g_EndNodeCount = 0;

// This stores the amount of nodes that are in the frustum
int g_TotalNodesDrawn = 0;

// Set the current render mode to triangles initially
bool g_bRenderMode = true;

// Turn lighting on initially
bool  g_bLighting     = true;							

// This stores the variable that increases the rotation angle for our terrain (not important)
float g_RotateX = 0;
*/
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define SKY_MODEL "sky.3ds" // univerzalni jmeno modelu

GBackGround::GBackGround(GEngineKulic *engine) :
GObject(engine)
{
	m_type    = GOBJ_BACK_GROUND;
	m_kengine = engine;
	
   m_start_time = 1000;
   m_bAsync     = FALSE;
   SetPeriod(1000, 0, FALSE);

//	m_texture = htexture.GetTexture("sterk.bmp");
	m_map_model = hmodel.LoadModel(engine->m_map.basic_model, H3D_DL_OBJECTS);
	
	
	if (strcmp(engine->m_map.ground_model, "noground") != 0 ) {
		m_map_ground = hmodel.LoadModel(engine->m_map.ground_model, H3D_DL_OBJECTS);
	}
	else m_map_ground = NULL;

	if (strcmp(engine->m_map.roof_model, "noroof") != 0 ) {
		m_map_roof = hmodel.LoadModel(engine->m_map.roof_model, H3D_DL_OBJECTS);
	}
	else m_map_roof = NULL;
	
	if (strcmp(engine->m_map.sky_texture, "nosky") != 0 ) {
		m_sky = hmodel.LoadModelReTextured(SKY_MODEL, engine->m_map.sky_texture, "", H3D_DL_MODEL);
	}
	else m_sky = NULL;
	
//	m_octree.GetSceneDimensions(g_pVertices, g_NumberOfVerts);

	// Here we pass in the information to create the root node.  This will then
	// recursively subdivide the root node into the rest of the node.
//	m_map_model.m_model
//	m_octree.CreateNode(g_pVertices, g_NumberOfVerts, g_Octree.GetCenter(), g_Octree.GetWidth());
}

GBackGround::~GBackGround()
{
	// odhlaseni modelu
	hmodel.RemoveModel(m_sky);
	m_sky = NULL;
	
	hmodel.RemoveModel(m_map_model);
	m_map_model = NULL;
	
	hmodel.RemoveModel(m_map_roof);
	hmodel.RemoveModel(m_map_ground);
}

void GBackGround::Render()
{
 	glPushMatrix();
	glTranslated(0, 0, 0);

	// Obloha se musi kreslit bez orezavani !!!
	if (m_sky != NULL) {
		if (m_kengine->m_fog) glDisable(GL_FOG);
	 	glMatrixMode(GL_PROJECTION);
		glPushMatrix();
   	glLoadIdentity();
	   gluPerspective(m_kengine->m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, 3000.0f);	// 1.0f - to se nesmi sdat < nez 1.0!!!
	  	glMatrixMode(GL_MODELVIEW);
		
		glDisable(GL_LIGHTING);
		m_sky->Render(0, 0, 0);
		glEnable(GL_LIGHTING);
		
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
	  	glMatrixMode(GL_MODELVIEW);
		
		if (m_kengine->m_fog) glEnable(GL_FOG);
	}
	
	GLfloat lightM[4] = {0.2f,0.2f,0.2f,1.0f};       
	GLfloat lightG[4] = {0.9f,0.9f,0.9f,1.0f};       
	GLfloat lightR[4] = {0.6f,0.6f,0.6f,1.0f};       
	

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightM);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightM);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightM);

	if (m_map_model != NULL)
		m_map_model->Render(0, 0, 0);

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightR);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightR);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightR);

	if (m_map_roof != NULL)
	m_map_roof->Render(0, 0, 0);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightG);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightG);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightG);
	
	if (m_map_ground != NULL)
		m_map_ground->Render(0, 0, 0);
	
	glPopMatrix();
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightM);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightM);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightM);
}
/*	
  	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
  	glLoadIdentity();
   gluPerspective(m_kengine->m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, 3000.0f);	// 1.0f - to se nesmi sdat < nez 1.0!!!
  	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslated(0, 0, 0);

	// Obloha se musi kreslit bez orezavani !!!
	if (m_sky != NULL) {
		if (m_kengine->m_fog) glDisable(GL_FOG);
//	  	glMatrixMode(GL_PROJECTION);
//		glPushMatrix();
//   	glLoadIdentity();
//	   gluPerspective(m_kengine->m_eye_angle,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, 3000.0f);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   //	glMatrixMode(GL_MODELVIEW);
	//	glPushMatrix();
	//	glLoadIdentity();
		m_sky->Render(0, 0, 0);
	//	glPopMatrix();
//		glMatrixMode(GL_PROJECTION);
//		glPopMatrix();
 //  	glMatrixMode(GL_MODELVIEW);
		if (m_kengine->m_fog) glEnable(GL_FOG);
	}
	
	GLfloat lightM[4] = {0.2f,0.2f,0.2f,1.0f};       
	GLfloat lightG[4] = {0.9f,0.9f,0.9f,1.0f};       
	GLfloat lightR[4] = {0.6f,0.6f,0.6f,1.0f};       
	

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightM);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightM);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightM);

	if (m_map_model != NULL)
		m_map_model->Render(0, 0, 0);

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightR);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightR);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightR);

	if (m_map_roof != NULL)
	m_map_roof->Render(0, 0, 0);
	
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightG);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightG);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightG);
	
	if (m_map_ground != NULL)
		m_map_ground->Render(0, 0, 0);
	
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
  	glMatrixMode(GL_MODELVIEW);
	*/
