//KULIC2

//
// File: GKulic.h
// Created by: berny <(null)>
// Created on: Tue Feb  4 09:54:23 2003
//

#include "ph.h"
#include "GKulic.h"
#include "GWeapon.h"
#include "GAI.h"
#include "GKulicModel.h"
#include "GEngineKulic.h"

GKulic::GKulic(GEngine *engine, H3DModel *model3D, st_kulic_params *params) : 
	GActiveObject(engine, model3D)
{
	// kopirovani nastaveni
	m_params = *params;
	
	// nastaveni casovani postavicky
   m_start_time = rand()%m_params.period_ms;
   m_bAsync     = FALSE;
   SetPeriod(m_params.period_ms, 0, FALSE);
	
	// nastaveni panacka
	m_acceleration = m_params.base_acceleration;
	m_antislide = m_params.antislide;
	m_speed = m_params.base_speed;	
	
	m_type = GOBJ_KULIC;
	
	m_frags = 0;
	
	m_lives = 100;
	// nastaveni zbrani a podobneho
	
	// inicializujeme zbrane
	for (int i = 0; i < MAX_WEAPONS; i++) m_weapons[i] = new GWeapon(m_engine, i, this);
	// nastavime preferovanou zbran - jinak dame nahodnou
	if (m_params.weapon_prefered != -1) {
		m_weaponaID = m_params.weapon_prefered;
		m_weapona = m_weapons[m_params.weapon_prefered];
	}
	else {
		m_weaponaID = rand()%MAX_WEAPONS;
		m_weapona = m_weapons[m_weaponaID];
	}
	
	m_weapon_change_ms = 0;
	m_kulicmodel = NULL;

	printf("New kulic in game\n");
	
}


GKulic::~GKulic()
{
	// odmazani zbrani
	for (int i = 0; i < MAX_WEAPONS; i++) SAFE_DELETE(m_weapons[i]);

	// 
	SAFE_DELETE(m_kulicmodel);
}


void GKulic::DoEvent()
{

	GActiveObject::DoEvent();
	
	// pozadavek na zmenu zbrane - nasledujici
	if ((m_action3 || m_action2) && m_weapon_change_ms <= 0) {
		
		// najdeme novy index zbrane
		if (m_action3) { if (++m_weaponaID >= MAX_WEAPONS) m_weaponaID = 0; } 
		else { if (--m_weaponaID < 0) m_weaponaID = MAX_WEAPONS-1; }
		
		m_weapona = m_weapons[m_weaponaID];  // aktualizace pointeru na zbran
		m_weapon_change_ms = m_params.weapon_change_ms; // nastavime, za jak dlouho pujde zmenit zbran
	}
	else 
		if (m_weapon_change_ms > 0) m_weapon_change_ms -= m_params.period_ms;
	
		
	m_weapona->DoEvent(m_params.period_ms, m_action1);
	
	// posuneme animaci modelu
	if (m_kulicmodel != NULL) {
		m_kulicmodel->AnimateModel(m_params.period_ms, m_forward, m_backward, m_left, m_right, m_lives);
	}
	
	// pripadne pozadame o oziveni
	if (!m_active && m_action4)
		((GEngineKulic*)m_engine)->WantRevive(this);
		
}

bool GKulic::LostLives(int lives)
{
//	printf("loosing %d lives\n", lives);
	
	if (m_active && (m_lives -= lives) < 0) {
		
		printf("Kulic died\n");
		
		m_active = false;
		

		m_up = false;
		m_down = false;
		m_left = false;
		m_right = false;
		m_forward = false;  
		m_backward = false; 
		m_action1 = false;
		m_action2 = false;
		m_action3 = false;
		m_action4 = false;
		m_action5 = false;		
		m_rotX = 0;
		m_rotY = 0;
		m_rotZ = 0;
		
		return true;
	}
	
	return false;
}

bool GKulic::Hitted(GActiveObject *object)
{
	// chceme se strkat :-)
	return true;
}

void GKulic::Render()
{
	if (m_kulicmodel != NULL) {
		// nastavime pozici matic atd.
		if (!RenderRotoMovePushMatrix()) return;

		// kreslime model
		 m_kulicmodel->RenderModel(m_position.x, m_position.y, m_position.z, m_weapona);
	
			// obnoveni stare matice - PushMatrix volal RenderRotoMovePushMatrix
		glPopMatrix();
	}
	else 
		GActiveObject::Render();
}


// rika hracovi, ze se muze ozivit na pozici x, y, z 
void GKulic::Revive(float x, float y, float z)
{	
	m_position.x = x;
	m_position.y = y;
	m_position.z = z;
		
	m_weapon_change_ms = 0;	
	m_lives = 100;	
	for (int i = 0; i < MAX_WEAPONS; i++) m_weapons[i]->RestoreWeapon();
	
	m_active = true;
	
	printf("Kulic revived\n");
}
