// GObject.h: interface for the GObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GOBJECT_H__3A6C0C07_BA51_494B_8175_BE32F00613BE__INCLUDED_)
#define AFX_GOBJECT_H__3A6C0C07_BA51_494B_8175_BE32F00613BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TimeManager.h"

// typy objektu - je nutne pri rozpoznavani kolizi
#define GOBJ_UNKNOWN      0x0 
#define GOBJ_BACK_GROUND  0x0 
// GActive se pozna, ze lze  (m_type & 1) != 0
#define GOBJ_ACTIVE       0x001
#define GOBJ_KULIC        0x101  
#define GOBJ_SHOOT        0x011  

// predpoklada pointer na GObject
#define IS_AOBJECT(x) ((((x)->m_type) & 0x001) == 0x001)
#define IS_KULIC(x)   ((((x)->m_type) & 0x101) == 0x101) 
#define IS_SHOOT(x)   ((((x)->m_type) & 0x011) == 0x011) 

class GEngine;

// Objekt hry, se kterym pracuje Engine. Pouziva se jako zakladni bazovu objekt pro vsechny ve hre
class GObject : public CTimeEvent
{
public:

	// vola se jako pozadavek, ze ma byt objekt zrusen. Bud je o to pozadan engine, nebo (pokud enigne neni) se provede rovnou fyzicke zruseni
	virtual void WantBeDeleted();

	// odhlasi se z enginu a provede delete this;
	virtual void SelfDelete();

	// Zobrazi objekt
	virtual void Render();
	
	// Pohne objektem - volano z TM kazdych m_milisec_timer
   virtual void DoEvent();
   virtual void DoEvent(long /*elapsed*/){};// pro asynchronni udalost
	
	// konstrukcne destrukcni rutinky
	GObject(GEngine *engine);
	virtual ~GObject();

	// ukazatel na engine 
	GEngine *m_engine;

	// zda uz byl zadan pozadavek na zruseni - aby se objekt o zruseni nedozadoval > 1
	bool m_want_be_deleted;

	// typ objektu - viz #define nahore
   int m_type;
	
	// pri registrovani v enginu engine vyplni ID objektu a stara se o nej. Pouziva se, aby slo objekt
	// "rychle" smazat (rozumej kostantni slozitosti a ne linearni)
	int m_engineID; 
};

#endif // !defined(AFX_GOBJECT_H__3A6C0C07_BA51_494B_8175_BE32F00613BE__INCLUDED_)
