//KULIC2

// GShoot.cpp: implementation of the GShoot class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "GShoot.h"
#include "GKulic.h"
#include "GEngine.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// nacte modely strel a nastavi je do parametru
void GShoot::PrepareShootParams()
{
	for (int i = 0; i < MAX_SHOOTS; i++)
		GShootParams[i].model = hmodel.LoadModel(GShootParams[i].modelfile, H3D_DL_MODEL);
}

// zrusi modely strel v parametrech
void GShoot::DestroyShootParams()
{
	for (int i = 0; i < MAX_SHOOTS; i++) {
		hmodel.RemoveModel(GShootParams[i].model);
		GShootParams[i].model = NULL;
	}
}

GShoot::GShoot(GEngine *engine, st_shoot_params *params, GKulic *owner) 
 : GActiveObject(engine, params->model)
{

	m_type = GOBJ_SHOOT;
	
	m_params = *params;
	
	// nastaveni casovace
   m_start_time = rand()%m_params.period_ms;
   m_bAsync     = FALSE;
   SetPeriod(m_params.period_ms, 0, FALSE);

	// nastaveni strely
	m_acceleration = m_params.acceleration;
	m_speed = m_params.speed;
	
	m_owner = owner;
//	m_owner->m_frags++;

	m_veight = m_params.weight;
	
	m_range = m_params.range;
	m_active = true;
	
	
//printf("New shoot : size x : %f, %f, %f\n", m_size.x, m_size.y, m_size.z);
	
/*	// velikost strely
	m_size.x = 1;
	m_size.y = 1;
	m_size.z = 5;	
	*/
}

GShoot::~GShoot()
{

}

/////////////////////////////////////////////////////////////////////////////////////////////

void GShoot::DoEvent()
{
	GActiveObject::DoEvent();

	// zkousime, zda strela jiz ndeoletela na konec sve cesty
	if ((m_range -= m_params.speed) <= 0) {
		
		//TODO: aby strely explodovaly		
		for (int i = 0; i < m_params.explosive; i++ ) {
			// vytvorime novou strelu
			GShoot *shoot = new GShoot(m_engine, &GShootParams[m_params.after_explode], m_owner);

			// zjistime pohyb vpred
			shoot->m_forward = true;

			// kopie pozice i pohybu
			shoot->m_position = m_position;
			shoot->m_rotation.y = (rand()%360);

			// pridame strelu do enginu
			m_engine->AddObject(shoot);
		}
		
		// Smazani sebesama
      WantBeDeleted();
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////

bool GShoot::Hitted(GActiveObject *object)
{

	// aby se nestavalo, ze nekdo dostane dvojty zasah atp.
	if (m_want_be_deleted) return false;
		
	// pri narazu do zdi
	if (object == NULL) {
		// tady by mela strela jeste explodovat!!!
      WantBeDeleted();
		// zatim se strely jen odrazi od sten :-)
//		m_rotation.y = (rand()%360);
 		return false;
	}

	
   if (IS_KULIC(object) && object != m_owner) {
		// ubereme zivoty
		if (((GKulic*)object)->LostLives(m_params.demage)) 
			// pripadne zvedneme fragy :-)
			if (m_owner && IS_KULIC(m_owner)) ((GKulic*)m_owner)->m_frags++;
				
		// strela trochu soupere "orstrci"
		object->m_sliding.x += m_moveing.x*m_veight/object->m_veight;
		object->m_sliding.y += m_moveing.y*m_veight/object->m_veight;
		object->m_sliding.z += m_moveing.z*m_veight/object->m_veight;
			
		// a sami se smazeme			
      WantBeDeleted(); 
	}
	
	
	return false; // strely jsou zatim neodstrkavaji - ale staci jen zmenit
}

void GShoot::Render()
{
	glDisable(GL_LIGHTING);
		GActiveObject::Render();
	glEnable(GL_LIGHTING);
}
