// GShoot.h: interface for the GShoot class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GSHOOT_H__63086953_A177_4C84_885B_3F3BFBA2938A__INCLUDED_)
#define AFX_GSHOOT_H__63086953_A177_4C84_885B_3F3BFBA2938A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GActiveObject.h"

#define MAX_SHOOTS 5 // pocet ruznych typu projektilu

typedef struct {
	H3DModel*  model;         // 3D model sterly
	char       modelfile[64];      // jmeno 3DSka s modelem strely

	int       period_ms;      // perioda opakovani cyklu - v milisekundach
	
	float     speed;         // rychlost pohybu
	float     rspeed;        // pridava se nejakay rand()%rspeed k speed
	float     range;         // dolet
	float     rrange;        // pridavny rnadom dolet
	
	float     acceleration;  // akcelerace strely
	
	int        demage;        // kolik ubere zivotu
	int        dead;          // ID smrti, ktera postihne zabiteho
	
	int        explosive;     // zda exploduje
	int        after_explode; // strely, ktere maji vzniknout pri explozi
	
	float     y;             // vyska, ve ktere strela leti (zacina let)
	
	bool       falling;       // zda pada - nektere strely budou stoupat a pak padat - granaty
	float     upseed;        // rychlost stoupani - jeste musime vyresit gravitaci
	
	float      weight;        // vaha strely - pri predavani rychlosti
	
	int        souned_explode; // zvuk exploze?????????
} st_shoot_params;

extern st_shoot_params GShootParams[MAX_SHOOTS];  // v Params.cpp

class GKulic;

class GShoot : public GActiveObject  
{
public:
	virtual void DoEvent();
	GShoot(GEngine *engine, st_shoot_params *params, GKulic *owner);
	
	virtual ~GShoot();
   /** No descriptions */
   bool Hitted(GActiveObject *object);

	virtual void Render();
	
	// melo by se volat pri jen zapnuti a vypnuti enginu
	static void PrepareShootParams(); // nacte modely strel a nastavi je do parametru
	static void DestroyShootParams(); // zrusi modely strel v parametrech


	GKulic          *m_owner;  // kdo strelu vysrelil
	st_shoot_params  m_params; // parametry strely
	double           m_range;  // dolet strely - kdyz <= 0, strela zanika
};

#endif // !defined(AFX_GSHOOT_H__63086953_A177_4C84_885B_3F3BFBA2938A__INCLUDED_)
