//
// File: H3DModelStore.h
// Created by: berny <berny@seznam.cz>
// Created on: Tue Jun 24 08:06:51 2003
//

#ifndef _H3DMODELSTORE_H_
#define _H3DMODELSTORE_H_


// Melo by fungovat jako HTextureStore - obsahuje v sobe vsechny modely
// a zpravuje je. Je proto, aby se 1 model nenacital vicekrat

#include "H3DModel2.h"

#define MAX_MODELS 100

class H3DModelStore
{
	public:
		H3DModelStore();
		~H3DModelStore();
	
		H3DModel* LoadModel(const char* filename, int displayLists = H3D_DL_NO, bool mirror_x = false, bool mirror_y = false, bool mirror_z = false);
		H3DModel* LoadModelReTextured(const char* filename, const char* texturename, const char* texturename_old, int displayLists = H3D_DL_NO, bool mirror_x = false, bool mirror_y = false, bool mirror_z = false);
		
  		// smazne texturu
  		void RemoveModel(H3DModel* model);
  
		// Uplne a opravdu zrusi vsechny textury
		void DestroyAllModels();
		
		// H3DModelStore interface
	protected:
		
		// H3DModelStore variables
		// informace o 1 modelu
		struct st_model {
			H3DModel  *model;        // vlastni GL textura
			int       used;         // kolikrat je uzit - kolik objektu ji potrebuje
			char      file[255];    // jmeno souboru, ze ktereho je model
			char      texture[255]; // kdyby byl model nacten s jinou texturou
			char      texture_old[255]; // pripadna nahrazovana textura
			bool      mirror_x;     // zrcadleni v X
			bool      mirror_y;     // zrcadleni v Y
			bool      mirror_z;     // zrcadleni v Z
			int       dlist;        // parametry display listu
		};

		// data
		st_model   *m_model[MAX_MODELS]; 
		int         m_models; 	
	
		// fyzicky znici model
		void DestroyModel(int ID);	
};

extern H3DModelStore hmodel;

#endif	//_H3DMODELSTORE_H_
