//
// File: HCollisions.h
// Created by: berny <(null)>
// Created on: Wed Mar 19 22:21:26 2003
//

#ifndef _HCOLLISIONS_H_
#define _HCOLLISIONS_H_


#include "3DMath.h"

#define CELL_FIELDS 2

class GActiveObject;
class H3DModel;

// data na jeden ctverecek (casem mozna krychlicku) kolizni mapy : 
typedef struct {
	// mozna by se mel pouzit stack !!!
	vector<GActiveObject*> pobject; // seznam objektu v krychlicce
	vector<CVector3> vPolygons; // seznam trojuhelniku v krychlicce
	int objects;  // jejich pocet
	int triangles; // pocet rojuhelniku
} st_colisioncell;

// data, ktera ma v sobe GActiveObject
typedef struct {
	st_colisioncell *cell[CELL_FIELDS]; // misto, kde zrovna objekt je (byl) v ircitem poli
	int cell_ID[CELL_FIELDS];           // ID v poli
} st_CollisActiveObj;

// vlastnitrida pro detekce kolizi
class HCollisions
{
	public:
		// velikost ctverecku s nasekanim sveta a soubor s objektem obsahujici redikovanou mapu pro potreby kollize
		HCollisions(float cellszX,  float cellszY, float cellszZ, H3DModel* scenemodel);
		HCollisions(float cellszX,  float cellszY, float cellszZ, char* modelname);
	
		HCollisions(CVector3 cellsize,  char* modelname);
		HCollisions(CVector3 cellsize, H3DModel* scenemodel);
		~HCollisions();
	
		// Prida dalsi objekt do sveta - predpoklada, ze uz ma platnou pozici....
		void AddActiveObject(GActiveObject *obj);
	
		// Odebera objekt z kolizniho sveta
		void RemoveActiveObject(GActiveObject *obj);
	
		// Otestuje objekt po presunuti
		void HitTest(GActiveObject *obj);
	
		void RenderCenters();
	
	protected:
	
		// inicializuje ruzne promene a vytvori pole krychlicek, do kozade nasype trojuhelniky ze sceny, ktere ji patri
		void Inicialize(CVector3 cellsize, H3DModel* scenemodel);
	
		// zkusi hitt se vsemi objekty v cellu a obj
		void TestHitting(GActiveObject *obj, st_colisioncell *cell);
	
		// prida objekt do ctverecku + test, zda tam uz neni 
		void AddObjToCell(GActiveObject *obj, st_colisioncell *cell, int field);

		// smaze objekt ze ctverecku
		void RemoveObjFromCell(GActiveObject *obj, int field);
	
		// vraci ukazatel na cell, podle ukazatele na pozici
		st_colisioncell* GetCell(CVector3 *position, int field);
		
		// docasna data - vzdy pro jeden 
		bool m_undomove;        // zda bude potreba pohnout se zpet;
		bool m_changedmovening; // zda uz hrac predal svoji rychlost (hypnost) nekomu juinemu
		st_colisioncell *m_newcell[CELL_FIELDS]; // pripadne nase celsy, kam se naz objekt posunul - aby se pocitali pri narazech jen jedenkrat
		
	
		// HCollisions variables - staticka data
	
		CVector3 m_cellsize; // rozmwery kvadriku
		
		
		CVector3 m_minsz[CELL_FIELDS]; // minimalni souradnice -- hlidaji, aby nekdo mimo nechtel do kolizniho prostoru
		                               // je pro kazde poler zvlast, protoze pole jsou vzajemne posunuta
		CVector3 m_maxsz; // maximalni souradnice 
	
		st_colisioncell *m_field[CELL_FIELDS]; // ukazatel na okenka
		int m_cells[CELL_FIELDS];              // pocet okenek
		int m_cells_in_row;                    // na jedne radce  - jende x-ove radce
		int m_cells_in_plane;                  // na jedne rovine - rovine x*z
		
};


#endif	//_HCOLLISIONS_H_

