// HTextureStore.h: interface for the HTextureStore class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_)
#define AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

 // to je zbytecne moc (alespon doufam)
#define MAX_TEXTURES 100

// Hlida vsechnu textury - obsahuje nacitani, niceni,...........
// pri nekalikanasobnem pozadavku o nacteni stejne textury vraci pokazde
// stejny ukazatel, ale zvysuje pocet uziti textury. Pri pozadavku na odmazani
// textury snizi pocet uziti textury, a kdyz je pocetpouziti == 0, tak teprve texturu
// fyzicky smazne
//
// pri pouzivani alphy a blendigu plati, ze automaticka alpha se pozna tak, se seoubor s ni se jmenuje
// stejne, jako original, ale ma na konci pred .xxx pridane '+'. Soubor s blendigem ma pridane '-'

class HTextureStore  
{
public:
	SDL_Surface* LoadBitmap(const char *filename, bool convert_to_smallchars = true);
	void SetNullTexture();
	void SetTexture(int ID);
	
	// vrati id textury, pripadne vytvori novou
	int GetTexture(const char *file, int min_filter, int mag_filter, bool mipmaps);
	// pouziva defaultove parametry
	int GetTexture(const char *file);
	
	// nacte texturu s alpha hodnotou - zatim nedodelane!!!
	int GetTextureWithAlpha(const char *file, const char *alphafile);
	int GetTextureWithBlend(const char *file, const char *blendfile);

	// pokusi se k souboru najit i soubor s maskou - je stejny jako puvodni, ale na konci ma navic misto *.jpg *+.jpg   pro pripad, ze to byl jpeg...
	int GetTextureAutoAlpha(const char *file);
	int GetTextureAutoBlend(const char *file);
	int GetTextureAuto(const char *file); // i s Alpha/Blend - podle toho, co pujde

	// nastavy aktualni texturu podle ID (pro pouzivani)
	HTextureStore();
	virtual ~HTextureStore();
	
  // smazne texturu
  void RemoveTexture(int ID);
  
	// Uplne a opravdu zrusi vsechny textury
	void DestroyAllTextures();
	
  // nastavi kvalitu textur - prpustne hodnoty 0, 1, 2
  void SetTextureGeneratingQuality(int quality);

	// informace o 1 texture
	struct st_texture {
		GLuint gl_texture; // vlastni GL textura
		int    used;       // kolikrat je uzita - kolik objektu ji potrebuje
		bool   alpha;      // zda je pritomne alpha hodnota
		bool   blending;   // zda je alpha i pro blending - musi se pri renderovani pouzivat H3DModelBlendQueue
		char   file[100];  // jmeno souboru, ze ktereho je textura
	};

	// data
	st_texture *m_texture[MAX_TEXTURES]; 
	int         m_textures; 

	// default parametry pro tvoreni textur
	bool        m_mipmaps;    // zda se maji generovat mipmapy
	int         m_min_filter; // filtr pro zmensovani
	int         m_mag_filter; // filtr pro zvetsovani


private :
	// vytvori novou texturu - volane z GetTexture
	int CreateTexture(const char* file, int min_filter, int mag_filter, bool mipmaps);
	// fyzicky znici texturu
	void DestroyTexture(int ID);
};

extern HTextureStore htexture;

#endif // !defined(AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_)
