//KULIC2

// MMenu.cpp: implementation of the MMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "MMenu.h"
#include "GRun.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


MMenu::MMenu(GRun *run)
{
	m_run = run;

	GLfloat lightM[4] = {0.8f,0.8f,0.8f,1.0f};       
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, lightM);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, lightM);
	glLightfv(GL_LIGHT0, GL_AMBIENT, lightM);
	
	
   m_back_ground = htexture.GetTexture("menu.jpg");
//	m_back_ground = htexture.GetTextureWithAlpha("menu.jpg", "menu2.jpg");
 
	m_logo_model.LoadModel("logo.3ds");
//	m_logo_model.LoadModel("nohy.ha3");
//	m_logo_model.LoadModel("n00.3ds");
	

	m_rott = 0;
	
	// ve hre by se mohlo stat, ze nam nekdo zmeni projekcni matici
  	glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
	gluPerspective(45,SCREEN_WIDTH/SCREEN_HEIGHT,1.0f, 3000.0);	// 1.0f - to se nesmi sdat < nez 1.0!!!
   glMatrixMode(GL_MODELVIEW);

}

MMenu::~MMenu()
{
   htexture.RemoveTexture(m_back_ground);
}

// zobrazi menu (aktualni stav)
void MMenu::Render()
{

	glLoadIdentity();
	
	// spocitame zobrazovany kvadr. Vse mimo rovnou vyhodime
	frustum.CalculateFrustum();
	
	glTranslatef(0.0f, 0.0f, -2.2f);

	
	// Nastaveni textury pozadi
	htexture.SetTexture(m_back_ground);

	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -18.0f,   14.0f, -30.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -18.0f,  -14.0f, -30.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  18.0f,  -14.0f, -30.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  18.0f,   14.0f, -30.0f);
	glEnd();	
	
	// logo
	glPushMatrix();
	glTranslatef(8.0f, -6.0, -20.0f);
	glRotatef(m_rott, 0.0f, 1.0f, 0.0f);
	glScalef(1.4f, 1.4f, 1.4f);
	m_logo_model.Render(8.0f, -6.0, -20.0f);
	glPopMatrix();
	

	// napsani nastavei hry
	hfont.printf(430, 420, "Map name X,C");
	hfont.printf(430, 400, gsetting.m_map[gsetting.m_startgame.mapID].name);
	
	hfont.printf(430, 360, "Character V,B");
	hfont.printf(430, 340, gsetting.m_char[gsetting.m_startgame.charID].name);

	hfont.printf(430, 300, "Skin N,M");
	char s[100]; sprintf(s, "%d", gsetting.m_startgame.skinID);
	hfont.printf(430, 280, s);

	hfont.printf(10, 10, "Bernard Lidicky, Zdenek Boswart, Martin Manak");

}

// reaguje na stisk klavesy
void MMenu::KeyDown(Uint8 key)
{
	switch (key) {

	case SDLK_ESCAPE:
		m_run->ExitProgram();
		break;
	case SDLK_RETURN:
		m_run->StartGame();
		break;
	case SDLK_x:
		if (--gsetting.m_startgame.mapID < 0) gsetting.m_startgame.mapID = gsetting.m_maps-1;
		break;
	case SDLK_c:
		if (++gsetting.m_startgame.mapID >= gsetting.m_maps) gsetting.m_startgame.mapID = 0;
		break;
	case SDLK_v:
		if (--gsetting.m_startgame.charID < 0) gsetting.m_startgame.charID = gsetting.m_chars-1;
		gsetting.m_startgame.skinID = 0;
		break;
	case SDLK_b:
		if (++gsetting.m_startgame.charID >= gsetting.m_chars) gsetting.m_startgame.charID = 0;
		gsetting.m_startgame.skinID = 0;
		break;
	case SDLK_n:
		if (--gsetting.m_startgame.skinID < 0)
			gsetting.m_startgame.skinID = gsetting.m_char[gsetting.m_startgame.charID].skins-1;
		break;
	case SDLK_m:
		if (++gsetting.m_startgame.skinID >= gsetting.m_char[gsetting.m_startgame.charID].skins)
			gsetting.m_startgame.skinID = 0;
		break;
	};
}


void MMenu::TimePassed(int milisec)
{
	m_rott += milisec/200.0f;
	m_logo_model.Animate(milisec);
}
